Subject: Re: Endianness problem with u32 classifier hash masks

From: jamal <[email-masked]>
Date: Sun, 04 Nov 2007 18:58:13 -0500

On Sun, 2007-04-11 at 02:17 +0100, Jarek Poplawski wrote:

> So, even if not full ntohl(), some byte moving seems to be
> necessary here.

I thinking you were close. I am afraid my brain is congested, even the
esspresso didnt help my thinking. 
It could be done with just fshift on the slow path (config time) of one
was to think hard;-> I am not too happy with the extra conversion on the
fast path, but how about the untested attached patch?

cheers,
jamal
 
diff --git a/net/sched/cls_u32.c b/net/sched/cls_u32.c
index 9e98c6e..6dd569b 100644
--- a/net/sched/cls_u32.c
+++ b/net/sched/cls_u32.c
@@ -93,7 +93,7 @@ static __inline__ unsigned u32_hash_fold(u32 key, struct tc_u32_sel *sel, u8 fsh
 {
 	unsigned h = (key & sel->hmask)>>fshift;
 
-	return h;
+	return ntohl(h);
 }
 
 static int u32_classify(struct sk_buff *skb, struct tcf_proto *tp, struct tcf_result *res)
@@ -615,7 +615,7 @@ static int u32_change(struct tcf_proto *tp, unsigned long base, u32 handle,
 	n->handle = handle;
 {
 	u8 i = 0;
-	u32 mask = s->hmask;
+	u32 mask = ntohl(s->hmask);
 	if (mask) {
 		while (!(mask & 1)) {
 			i++;